/***************************************************
*
*	ClinefitFunctions.h
*
*	These likelihood functions fit parameters to cline data.
*	Feed them derived ParamRec classes that contain cline parameters
*	and the appropriate corresponding derived MetropolisHastingsData 
*	classes that contain clinal data.
*
***************************************************/


#ifndef ClineFitFunctionsh
#define ClineFitFunctionsh = 1


#include "ParamRec.h"
#include "MetropolisHastings.h"
#include "ClineData.h"
#include "ClineGeneticData.h"
#include "ClinePhenotypicData.h"
//#include "DiseqLikelihood.h"
#include "ClineDiseqParamRec.h"
#include "ClineShapeCWTlTrDParamRec.h"
#include "ClineMultiCWTlTrDParamRec.h"
#include "ClineShapeCWTlTrTBDParamRec.h"
#include "ClineMultiCWTlTrTBDParamRec.h"
#include "ClineShapeCWTlTrTBQ2ParamRec.h"
#include "aVector.cpp"
#include "aMatrix.cpp"
#include "MemoryManager.h"


long double MaxLikeDevFromCline (ParamRec& p, MetropolisHastingsData* data);
		//use to fit clines without diesquilibrium estimation


long double MaxLikeDevFromClinePerHIData (ParamRec& p, MetropolisHastingsData* data, int loc);


long double MaxLikeDevFromClineQuantitative (ParamRec& p, MetropolisHastingsData* data, int trait);


long double MaxLikeDevFromClineQuantitative2 (ParamRec& p, MetropolisHastingsData* data);


long double MaxLikeDevFromClineAndDiseq6 (ParamRec& p, MetropolisHastingsData* data);
	//use to fit 6-parameter clines with disequilibrium estimation

long double MaxLikeDevFromClineAndDiseq7 (ParamRec& p, MetropolisHastingsData* data);
	//use to fit 7-parameter clines with disequilibrium estimation


long double MaxLikeDevFromClineAndDiseq9 (ParamRec& p, MetropolisHastingsData* data);
	//use to fit 9-parameter clines with disequilibrium estimation




#endif
