double MaxLikeDevFromCline (ParamRec& p, MetropolisHastingsData* data){
//	ClineShape2ParamRec* params = (ClineShape2ParamRec*) p.pointerToDerivedSelf;
	ClineGeneticData* theData = (ClineGeneticData*) data;
 	double runningTotal = 0.0;
	for (int loc=0;loc<theData->nloci;++loc){
   		runningTotal += MaxLikeDevFromClinePerHIData(p, theData, loc);
   		}
   	p.lnL(runningTotal);
 	return runningTotal;
	}//end MaxLikeDevFromCline (ParamRec&, MetropolisHastingsData*)



double MaxLikeDevFromClinePerHIData (ParamRec& p, MetropolisHastingsData* data, int loc){
//	ClineShape2ParamRec* params = (ClineShape2ParamRec*) p.pointerToDerivedSelf;
	ClineGeneticData* theData = (ClineGeneticData*) data;
	double lnL = 0.0;
	for(int i=0;i<theData->HybridIndicesByLocus.len();++i){
    	double obs = theData->HybridIndicesByLocus[i][loc].hi();
    	double x = theData->HybridIndicesByLocus[i][loc].x();
    	aList<double> coords;  coords.Append(x);
//    	double expected = params->ExpectedValue(coords);
    	double expected = p.ExpectedValue(coords);
    	expected = MAX(expected, 10.0e-5);//bounds lower limit to logit transform equivalent
    	expected = MIN(expected, 1.0-10.0e-5);//bounds upper limit to logit transform equivalent
     	lnL += obs * ln(expected);
     	lnL += (1.0 - obs) * ln(1.0 - expected);
   		}//end for i
//	params->lnL(lnL);
	p.lnL(lnL);
	return lnL;
	}//end MaxLikeDevFromClinePerHIData (ParamRec&, MetropolisHastingsData*, int)

