/******************************************************
*
*	ClineShapeCWTlTrTBParamRec.cpp
*
*	Parameters for a 3-part composite tanh cline defined by center, width,	
*	thetaL, thetaR, zL & zR.  The latter 4 parameters describe introgression
*	slopes and intercepts on the Left and Right sides of the cline.
*	The mean y-axis value of the cline varies for each trait on each side.
*
*	Use this as a virtual class for derived classes that add parameters.
*
******************************************************/

#ifndef ClineShapeCWTlTrTBParamReccpp
#define ClineShapeCWTlTrTBParamReccpp = 1

#include "ClineShapeCWTlTrTBParamRec.h"

	
ClineShapeCWTlTrTBParamRec::ClineShapeCWTlTrTBParamRec(void){
//  	SetPointerToDerivedSelf();
  	}


ClineShapeCWTlTrTBParamRec::ClineShapeCWTlTrTBParamRec(long double c, long double w,
													long double tL, long double tR,
													long double zL, long double zR,
													long double leftSideScore, 
													long double rightSideScore
													//aList<int>& onOff
													){
//  	SetPointerToDerivedSelf();
	lnL_= 0.0;
	lnLmaxMinusLnL_ = 0.0;	
  	c_=c;
  	w_=w;
	thetaL_=tL;
	thetaR_=tR;
	zL_=zL;
	zR_=zR;
	pL_=leftSideScore;
	pR_=rightSideScore;
//	paramOnOffList_=onOff;
//	for(int p=0;p<onOff.len();++p){paramsOn_.Append(p);}
//	for(int p=paramOnOffList_.len()-1;p>=0;--p){
//		if(paramOnOffList_[p]==0){
//			paramsOn_.Delete(p);}
//		}//p
	}


ClineShapeCWTlTrTBParamRec::ClineShapeCWTlTrTBParamRec(long double c, long double w,
													long double tL, long double tR,
													long double zL, long double zR,
													long double leftSideScore, 
													long double rightSideScore,
													double leftEnd, double rightEnd//,
													//aList<int>& onOff
													){
//  	SetPointerToDerivedSelf();
	lnL_= 0.0;
	lnLmaxMinusLnL_ = 0.0;	
  	c_=c;
  	w_=w;
	thetaL_=tL;
	thetaR_=tR;
	zL_=zL;
	zR_=zR;
	pL_=leftSideScore;
	pR_=rightSideScore;
//	paramOnOffList_=onOff;
//	for(int p=0;p<onOff.len();++p){paramsOn_.Append(p);}
//	for(int p=paramOnOffList_.len()-1;p>=0;--p){
//		if(paramOnOffList_[p]==0){
//			paramsOn_.Delete(p);}
//		}//p
  	LJunction(leftEnd);
  	RJunction(rightEnd);
  	}

/*
ClineShapeCWTlTrTBParamRec::ClineShapeCWTlTrTBParamRec(ClineFitInitializer& i, int trait_){
	//assumes the parameter analysis is turned on
  	SetPointerToDerivedSelf();
	lnL_= 0.0;
	lnLmaxMinusLnL_ = 0.0;	
  	c_=i.c_[trait_];
  	w_=i.w_[trait_];
	thetaL_=i.thetaL_[trait_];
	thetaR_=i.thetaR_[trait_];
	zL_=i.zL_[trait_];
	zR_=i.zR_[trait_];
	pL_ = i.aveScoreL_[trait_];
	pR_ = i.aveScoreR_[trait_];
//	ObjList<aList<int> >& ponoff = *(i.paramsOnOff_);
//	paramOnOffList_ = ponoff[0];
//	for(int p=0;p<paramOnOffList_.len();++p){
//		paramsOn_.Append(p);}
//	for(int p=paramOnOffList_.len()-1;p>=0;--p){
//		if(paramOnOffList_[p]==0){paramsOn_.Delete(p);}}
 	LJunction(i.leftEnd_);
  	RJunction(i.rightEnd_);
  	}
*/

ClineShapeCWTlTrTBParamRec::ClineShapeCWTlTrTBParamRec(ClineFitInitializer& i, int trait_){
	//assumes the parameter analysis is turned on
//  	SetPointerToDerivedSelf();
	lnL_= 0.0;
	lnLmaxMinusLnL_ = 0.0;	
  	c_=i.c_[trait_];
  	w_=i.w_[trait_];
	thetaL_=i.thetaL_[trait_];
	thetaR_=i.thetaR_[trait_];
	zL_=i.zL_[trait_];
	zR_=i.zR_[trait_];
//	pL_.Append(i.aveScoreL_[trait]);
//	pR_.Append(i.aveScoreR_[trait]);
	pL_ = i.aveScoreL_[trait_];
	pR_ = i.aveScoreR_[trait_];
//	ObjList<aList<int> >& ponoff = *(i.paramsOnOff_);
//	for(int p=0;p<8;++p){
//		paramOnOffList_.Append(ponoff[trait][p]);}
//	for(int p=0;p<paramOnOffList_.len();++p){
//		paramsOn_.Append(p);}
//	for(int p=paramOnOffList_.len()-1;p>=0;--p){
//		if(paramOnOffList_[p]==0){paramsOn_.Delete(p);}}
 	LJunction(i.leftEnd_);
  	RJunction(i.rightEnd_);
  	}


ClineShapeCWTlTrTBParamRec::ClineShapeCWTlTrTBParamRec(ClineShapeCWTlTrTBParamRec& p){
//  	SetPointerToDerivedSelf();
	lnL_= p.lnL_;
	lnLmaxMinusLnL_ = p.lnLmaxMinusLnL_;	
  	c_=p.c_;
  	w_=p.w_;
	thetaL_=p.thetaL_;
	thetaR_=p.thetaR_;
	zL_=p.zL_;
	zR_=p.zR_;
	xL_=p.xL_;
	xR_=p.xR_;
	pL_=p.pL_;
	pR_=p.pR_;
//	paramOnOffList_=p.paramOnOffList_;
//	paramsOn_=p.paramsOn_;
	}



ParamRec* ClineShapeCWTlTrTBParamRec::Duplicate(void){
	ClineShapeCWTlTrTBParamRec* copy = NEW ClineShapeCWTlTrTBParamRec(*this);
	return copy;
	}//end ClineShapeCWTlTrTBParamRec::Duplicate()


ClineShapeCWTlTrTBParamRec* ClineShapeCWTlTrTBParamRec::_Duplicate(void){
	ClineShapeCWTlTrTBParamRec* copy = NEW ClineShapeCWTlTrTBParamRec(*this);
	return copy;
	}//end ClineShapeCWTlTrTBParamRec::_Duplicate()


//void ClineShapeCWTlTrTBParamRec::SetPointerToDerivedSelf(void){
//  	pointerToDerivedSelf = (long) this;
//  	cout<<"setting in ClineShapeCWTlTrTBParamRec"<<endl;
//  	}//end ClineShapeCWTlTrTBParamRec::SetPointerToDerivedSelf()

long ClineShapeCWTlTrTBParamRec::GetPointerToDerivedSelf(void){
  	return (long) this;
  	}//end ClineShapeCWTlTrTBParamRec::SetPointerToDerivedSelf()



long double ClineShapeCWTlTrTBParamRec::B_L(int trait){
	//cline frequency at xL
//	if((paramsOn_[2] == 0) && (paramsOn_[4] == 0)){
//		return 0.0;
//		return leftVal(trait);
//		}//no introgression tail on left side
	return ClineShapeCWTlTrParamRec::B_L(trait);
	
	}//end ClineShapeCWTlTrTBParamRec::B_L(void)


long double ClineShapeCWTlTrTBParamRec::B_R(int trait){
	//cline frequency at xR
//	if((paramsOn_[3] == 0) && (paramsOn_[5] == 0)){
//		return 0.0;
//		return rightVal(trait);
//		}//no introgression tail on right side
	return ClineShapeCWTlTrParamRec::B_R(trait);
	}//end ClineShapeCWTlTrTBParamRec::B_R(void)


int ClineShapeCWTlTrTBParamRec::ChangeCenter(Ran3& ran, double sigma, 
							ParamRec* lowerLimits, ParamRec* upperLimits){
	//use normal distribution to vary center
	//return 0 for failure, 1 for success
	int validChange=false,tries=0;
	long double oldCenter = c_;
	ClineShapeCWTlTrTBParamRec* lower = (ClineShapeCWTlTrTBParamRec*) lowerLimits->GetPointerToDerivedSelf();
	ClineShapeCWTlTrTBParamRec* upper = (ClineShapeCWTlTrTBParamRec*) upperLimits->GetPointerToDerivedSelf();
	do{
		c_ = ran.NormDev(oldCenter, sigma);
		validChange = LJunction(lower->xL_);
		if(validChange){
			validChange = RJunction(upper->xR_);}
		if(validChange){
			validChange = MeetsParamCriteria(lowerLimits, upperLimits);}
		++tries;
		if(tries>20){
//			aString err("can't find a good value for center");
//			aError(err);
			tries = 0;
			sigma *= 0.9;
			if(sigma<1.0e-5){///bail out
				c_=oldCenter;
				validChange=1;}
			}
		}while(!(validChange));
	return validChange;
	}//end ClineShapeCWTlTrTBParamRec::ChangeCenter(Ran3&, double, ParamRec*, ParamRec*)


int ClineShapeCWTlTrTBParamRec::ChangeThetaL(Ran3& ran, double sigma, 
							ParamRec* lowerLimits, ParamRec* upperLimits){
	//use normal distribution to vary center
	//return 0 for failure, 1 for success
	int validChange=false,tries=0;
	long double oldThL = thetaL_;
	ClineShapeCWTlTrTBParamRec* lower = (ClineShapeCWTlTrTBParamRec*) lowerLimits->GetPointerToDerivedSelf();
	do{
		thetaL_ = ran.NormDev(oldThL, sigma);
		validChange = LJunction(lower->xL_);
		if(validChange){
			validChange = MeetsParamCriteria(lowerLimits, upperLimits);}
		++tries;
		if(tries>20){
//			aString err("can't find a good value for thetaL");
//			aError(err);
			tries = 0;
			sigma *= 0.9;
			if(sigma<1.0e-8){///bail out
				thetaL_=oldThL;
				validChange=1;}
			}
		}while(!(validChange));
	return validChange;
	}//end ClineShapeCWTlTrTBParamRec::ChangeThetaL(Ran3&, double, ParamRec*, ParamRec*)


int ClineShapeCWTlTrTBParamRec::ChangeThetaR(Ran3& ran, double sigma, 
							ParamRec* lowerLimits, ParamRec* upperLimits){
	//use normal distribution to vary center
	//return 0 for failure, 1 for success
	int validChange=false, tries=0;
	long double oldThR = thetaR_;
	ClineShapeCWTlTrTBParamRec* upper = (ClineShapeCWTlTrTBParamRec*) upperLimits->GetPointerToDerivedSelf();
	do{
		thetaR_ = ran.NormDev(oldThR, sigma);
		validChange = RJunction(upper->xR_);
		if(validChange){
			validChange = MeetsParamCriteria(lowerLimits, upperLimits);}
		++tries;
		if(tries>20){
//			aString err("can't find a good value for thetaR");
//			aError(err);
			tries = 0;
			sigma *= 0.9;
			if(sigma<1.0e-8){///bail out
				thetaR_=oldThR;
				validChange=1;}
			}
		}while(!(validChange));
	return validChange;
	}//end ClineShapeCWTlTrTBParamRec::ChangeThetaR(Ran3&, double, ParamRec*, ParamRec*)


int ClineShapeCWTlTrTBParamRec::ChangeLeftScore(Ran3& ran, double sigma, 
							ParamRec* lowerLimits, ParamRec* upperLimits){
	//use normal distribution to vary score
	//return 0 for failure, 1 for success
	int validChange=false, tries=0;
	long double oldScore = pL_;
	ClineShapeCWTlTrTBParamRec* lower = (ClineShapeCWTlTrTBParamRec*) lowerLimits->GetPointerToDerivedSelf();
	do{
		pL_ = ran.NormDev(oldScore, sigma);
		validChange = LJunction(lower->xL_);
		if(validChange){
			validChange = MeetsParamCriteria(lowerLimits, upperLimits);}
		++tries;
		if(tries>20){
//			aString err("can't find a good value for left side mean for trait ");err.cat(trait);
//			aError(err);
			tries = 0;
			sigma *= 0.9;
			if(sigma<1.0e-5){///bail out
				pL_=oldScore;
				validChange=1;}
			}
		}while(!(validChange));
	return validChange;
	}//end ClineShapeCWTlTrTBParamRec::ChangeLeftScore(Ran3&, double, ParamRec*, ParamRec*)


int ClineShapeCWTlTrTBParamRec::ChangeParam(int paramNum, Ran3& ran, 
							ParamRec* paramDeviations, 
							ParamRec* lowerLimits, ParamRec* upperLimits, long double weight){
	//return 0 for failure, 1 for success
//	int paramToAlter = paramsOn_[paramNum];
	//uses type conversion that circumvents usual virtual base class restrictions
	ClineShapeCWTlTrTBParamRec* deviations = (ClineShapeCWTlTrTBParamRec*) paramDeviations->GetPointerToDerivedSelf();
	int success = 0;
//	switch (paramToAlter){
	switch (paramNum){
	   case 0:
		  return ChangeCenter(ran, deviations->center()*weight, lowerLimits, upperLimits);
		  break;
		case 1:
		  return ChangeWidth(ran, deviations->width()*weight, lowerLimits, upperLimits);
		  break;
		case 2:
		   return ChangeThetaL(ran, deviations->thetaL()*weight, lowerLimits, upperLimits);
		   break;
		 case 3:
			 return ChangeThetaR(ran, deviations->thetaR()*weight, lowerLimits, upperLimits);
			 break;
		 case 4:
		 	 return ChangeZL(ran, deviations->zL()*weight, lowerLimits, upperLimits);
		 	 break;
		 case 5:
		 	 return ChangeZR(ran, deviations->zR()*weight, lowerLimits, upperLimits);
		 	 break;
		 case 6:
			return ChangeLeftScore(ran, deviations->leftVal()*weight, lowerLimits, upperLimits);
		 	 break;
		 case 7:
		return ChangeRightScore(ran, deviations->rightVal()*weight, lowerLimits, upperLimits);
		 	 break;
		 default:
		 	 break;//do next step
		 }//end switch
	aString errstr("bug: can't change shape param #");
	errstr.cat(paramNum+1);
	errstr.cat(" in a ");errstr.cat(NumParams());errstr.cat("-parameter cline model");
	aError(errstr);
	return  success;
	}//end ClineShapeCWTlTrTBParamRec::ChangeParam(int,Ran3&,ParamRec*,ParamRec*,ParamRec*)



int ClineShapeCWTlTrTBParamRec::ChangeRightScore(Ran3& ran, double sigma, 
							ParamRec* lowerLimits, ParamRec* upperLimits){
	//use normal distribution to vary score
	//return 0 for failure, 1 for success
	int validChange=false,tries=0;
	long double oldScore = pR_;
	ClineShapeCWTlTrTBParamRec* upper = (ClineShapeCWTlTrTBParamRec*) upperLimits->GetPointerToDerivedSelf();
	do{
		pR_ = ran.NormDev(oldScore, sigma);
		validChange = RJunction(upper->xR_);
		if(validChange){
			validChange = MeetsParamCriteria(lowerLimits, upperLimits);}
		++tries;
		if(tries>20){
//			aString err("can't find a good value for right side mean for trait ");err.cat(trait);
//			aError(err);
			tries = 0;
			sigma *= 0.9;
			if(sigma<1.0e-5){///bail out
				pR_=oldScore;
				validChange=1;}
			}
		}while(!(validChange));
	return validChange;
	}//end ClineShapeCWTlTrTBParamRec::ChangeRightScore(Ran3&, double, ParamRec*, ParamRec*)


int ClineShapeCWTlTrTBParamRec::ChangeWidth(Ran3& ran, double sigma, 
							ParamRec* lowerLimits, ParamRec* upperLimits){
	//use normal distribution to vary center
	//return 0 for failure, 1 for success
	int validChange=false,tries=0;
	long double oldWidth = w_;
	ClineShapeCWTlTrTBParamRec* lower = (ClineShapeCWTlTrTBParamRec*) lowerLimits->GetPointerToDerivedSelf();
	ClineShapeCWTlTrTBParamRec* upper = (ClineShapeCWTlTrTBParamRec*) upperLimits->GetPointerToDerivedSelf();
	do{
		w_ = ran.NormDev(oldWidth, sigma);
		validChange = LJunction(lower->xL_);
		if(validChange){
			validChange = RJunction(upper->xR_);}
		if(validChange){
			validChange = MeetsParamCriteria(lowerLimits, upperLimits);}
		++tries;
		if(tries>20){
//			aString err("can't find a good value for width");
//			aError(err);
			tries = 0;
			sigma *= 0.9;
			if(sigma<1.0e-5){///bail out
				w_=oldWidth;
				validChange=1;}
			}
		}while(!(validChange));
	return validChange;
	}//end ClineShapeCWTlTrTBParamRec::ChangeWidth(Ran3&, double, ParamRec*, ParamRec*)


int ClineShapeCWTlTrTBParamRec::ChangeZL(Ran3& ran, double sigma, 
							ParamRec* lowerLimits, ParamRec* upperLimits){
	//use normal distribution to vary center
	//return 0 for failure, 1 for success
	int validChange=false, tries = 0;
	long double oldZL = zL_;
	ClineShapeCWTlTrTBParamRec* lower = (ClineShapeCWTlTrTBParamRec*) lowerLimits->GetPointerToDerivedSelf();
	do{
		zL_ = ran.NormDev(oldZL, sigma);
		validChange = LJunction(lower->xL_);
		if(validChange){
			validChange = MeetsParamCriteria(lowerLimits, upperLimits);}
		++tries;
		if(tries>20){
//			aString err("can't find a good value for zL");
//			aError(err);
			tries = 0;
			sigma *= 0.9;
			if(sigma<1.0e-5){///bail out
				zL_=oldZL;
				validChange=1;}
			}
		}while(!(validChange));
	return validChange;
	}//end ClineShapeCWTlTrTBParamRec::ChangeZL(Ran3&, double, ParamRec*, ParamRec*)


int ClineShapeCWTlTrTBParamRec::ChangeZR(Ran3& ran, double sigma, 
							ParamRec* lowerLimits, ParamRec* upperLimits){
	//use normal distribution to vary center
	//return 0 for failure, 1 for success
	int validChange=false,tries=0;
	long double oldZR = zR_;
	ClineShapeCWTlTrTBParamRec* upper = (ClineShapeCWTlTrTBParamRec*) upperLimits->GetPointerToDerivedSelf();
	do{
		zR_ = ran.NormDev(oldZR, sigma);
		validChange = RJunction(upper->xR_);
		if(validChange){
			validChange = MeetsParamCriteria(lowerLimits, upperLimits);}
		++tries;
		if(tries>20){
//			aString err("can't find a good value for zR");
//			aError(err);
			tries = 0;
			sigma *= 0.9;
			if(sigma<1.0e-5){///bail out
				zR_=oldZR;
				validChange=1;}
			}
		}while(!(validChange));
	return validChange;
	}//end ClineShapeCWTlTrTBParamRec::ChangeZR(Ran3&, double, ParamRec*, ParamRec*)



long double ClineShapeCWTlTrTBParamRec::ExpectedValue(aList<long double>& coords){
	return Cline_at_X(coords[0]);//coords[0]=x, coords[1]=trait
	}//end ClineShapeCWTlTrTBParamRec::ExpectedValue(aList<double>&)


void ClineShapeCWTlTrTBParamRec::Initialize(ClineFitInitializer& i, int trait_){
	lnL_=0.0;
	lnLmaxMinusLnL_=0.0;
	c_= i.c_[trait_];
	w_ = i.w_[trait_];
	thetaL_ = i.thetaL_[trait_];
	thetaR_ = i.thetaR_[trait_];
	zL_ = i.zL_[trait_];
	zR_ = i.zR_[trait_];
//	pL_.Clear();//just in case of reinitialization
//	pR_.Clear();
//	paramOnOffList_.Clear();
//	paramsOn_.Clear();				
	pL_ = i.aveScoreL_[trait_];
	pR_ = i.aveScoreR_[trait_];
//	ObjList<aList<int> >& ponoff = *(i.paramsOnOff_);
//	for(int p=0;p<8;++p){
//		paramOnOffList_.Append(ponoff[trait][p]);}

	//now handle on-off scoring
//	for(int p=0;p<paramOnOffList_.len();++p){paramsOn_.Append(p);}
//	for(int p=paramOnOffList_.len()-1;p>=0;--p){
//		if(paramOnOffList_[p]==0){
//			paramsOn_.Delete(p);}}
	LJunction(i.leftEnd_);
	RJunction(i.rightEnd_);
	}//end ClineShapeCWTlTrTBParamRec::Initialize(ClineFitInitializer&, int)


long double ClineShapeCWTlTrTBParamRec::leftVal(int /*trait*/){
	return pL_;}


void ClineShapeCWTlTrTBParamRec::leftVal(long double lft,int /*trait*/){
	pL_ = lft;}


int ClineShapeCWTlTrTBParamRec::LJunction(double leftEnd){
	//finds point where left and center cline sections meet
//	if(thetaL_==0.0){
//		xL_ = leftEnd;
//		return 1;
//		}
	return ClineShapeCWTlTrParamRec::LJunction(leftEnd);
	}//end ClineShapeCWTlTrTBParamRec::LJunction(double)
	

int ClineShapeCWTlTrTBParamRec::MeetsParamCriteria (ParamRec* lowerLimits, ParamRec* upperLimits){
	//use type conversion that circumvents usual virtual base class restrictions
	ClineShapeCWTlTrTBParamRec* lower = (ClineShapeCWTlTrTBParamRec*) lowerLimits->GetPointerToDerivedSelf();
	ClineShapeCWTlTrTBParamRec* upper = (ClineShapeCWTlTrTBParamRec*) upperLimits->GetPointerToDerivedSelf();
	if(c_ <lower->c_){return 0;}
		else if (c_ > upper->c_){return 0;}
		else {}
	if(w_ <= 0.0){return 0;}
		else if (w_ > upper->w_){return 0;}
		else {}
	if(thetaL_ <lower->thetaL_){return 0;}
		else if (thetaL_ > upper->thetaL_){return 0;}
		else {}
	if(thetaR_ <lower->thetaR_){return 0;}
		else if (thetaR_ > upper->thetaR_){return 0;}
		else {}
	if(zL_ <lower->zL_){return 0;}
		else if (zL_ > upper->zL_){return 0;}
		else {}
	if(zR_ <lower->zR_){return 0;}
		else if (zR_ > upper->zR_){return 0;}
		else {}
	if((xL_ > xR_)||(xL_>c_)||(xR_<c_)){return 0;}
		else if(xL_ < lower->xL_){return 0;}
		else if(xR_ > upper->xR_){return 0;}
		else {}
	if(pL_ <lower->pL_){return 0;}
		else if (pL_ > upper->pL_){return 0;}
		else {}
	if(pR_ <lower->pR_){return 0;}
		else if (pR_ > upper->pR_){return 0;}
		else {}
	return 1;
	}//end ClineShapeCWTlTrTBParamRec::MeetsParamCriteria(ParamRec*, ParamRec*)


void ClineShapeCWTlTrTBParamRec::MultiplyParam(int paramNum, long double factor){
	//use to rescale a param deviation
	switch (paramNum){
		case 0:
		 	 c_ *= factor;
			 return;  break;
		 case 1:
		 	 w_ *= factor;
			 return;  break;
		 case 2:
		 	 thetaL_ *= factor;
			 return;  break;
		 case 3:
		 	 thetaR_ *= factor;
			 return;  break;
		 case 4:
		 	 zL_ *= factor;
			 return;  break;
		 case 5:
		 	 zR_ *= factor;
			 return;  break;
		 case 6:
		 	 pL_ *= factor;
			 return;  break;
		 case 7:
		 	 pR_ *= factor;
			 return;  break;
		 default:
		 	 break;//do below
		 }//end switch
	aString errstr("bug: can't rescale param #");
	errstr.cat(paramNum+1);
	errstr.cat(" in a ");errstr.cat(NumParams());errstr.cat("-parameter cline model");
	aError(errstr);
	}//ClineShapeCWTlTrTBParamRec::MultiplyParam(int, double)


int ClineShapeCWTlTrTBParamRec::NumParams(void){
	return 8;
	}//end ClineShapeCWTlTrTBParamRec::NumParams()


int ClineShapeCWTlTrTBParamRec::NumDerivedParams(void){
	return 2 + 3*traits();//xL,xR,bL[trait],bR[trait],deltaP[trait]
	}//end ClineShapeCWTlTrTBParamRec::NumParams()



aString* ClineShapeCWTlTrTBParamRec::ParamName(int paramNum){
	//returns name of parameter; first the varying params, then derived params
	int paramToReport, reportDerived=false;
	if(paramNum<NumParams()){
			paramToReport = paramNum;
			}
		else{//it's a derived param
			reportDerived=true;
			paramToReport = paramNum - NumParams();//renumbered for derived params
		}//end if
	if(!reportDerived){
			switch (paramToReport){
				case 0:
				  return NEW aString("center");
				  break;
				case 1:
				  return NEW aString("width");
				  break;
				case 2:
				  return NEW aString("thetaL");
				  break;
				case 3:
			 	 return NEW aString("thetaR");
			 	 break;
				case 4:
				  return NEW aString("zL");
				  break;
				case 5:
			 	  return NEW aString("zR");
			 	  break;
				case 6:
			 	  return NEW aString("pL");
			 	  break;
				case 7:
			 	  return NEW aString("pR");
			 	  break;
			 	default:
			 	  break;
			 	}//end switch
		 	}//if !reportDerived
		 else{//it's a derived parameter
			switch (paramToReport){
			 	case 0:
			 	 return NEW aString("xL");
			 	 break;
			 	case 1:
			 	 return NEW aString("xR");
			 	 break;
			 	case 2:
			 	 return NEW aString("p[xL]");
			 	 break;
			 	case 3:
			 	 return NEW aString("p[xR]");
			 	 break;
			 	case 4:
			 	 return NEW aString("deltaP");
			 	 break;
			    default:
			     break;
			 }//end switch
			}//end if reportDerived
	aString errstr("bug: can't return name of param #");
	errstr.cat(paramNum+1);
	errstr.cat(" in a ");errstr.cat(TotalParams());errstr.cat("-parameter cline model");
	aError(errstr);
	return NEW aString();//default shouldn't get here
	}//end ClineShapeCWTlTrTBParamRec::ParamName(int )



void ClineShapeCWTlTrTBParamRec::ParamString(aString& dataline, char sepchar){
	//a list of the values that will be printed to a big file
	ClineShapeCWParamRec::ParamString(dataline, sepchar);
	dataline.cat(sepchar);
	dataline.cat(thetaL_,6,15);
	dataline.cat(sepchar);
	dataline.cat(zL_,6,15);
	dataline.cat(sepchar);
	dataline.cat(pL_,2,15);
	dataline.cat(sepchar);
	dataline.cat(xL_,6,15);
	dataline.cat(sepchar);
	dataline.cat(thetaR_,6,15);
	dataline.cat(sepchar);
	dataline.cat(zR_,6,15);
	dataline.cat(sepchar);
	dataline.cat(pR_,2,15);
	dataline.cat(sepchar);
	dataline.cat(xR_,6,15);
	dataline.cat(sepchar);
	dataline.cat(B_L(),2,15);
	dataline.cat(sepchar);
	dataline.cat(B_R(),2,15);
	dataline.cat(sepchar);
	dataline.cat(DeltaP(),2,15);
	}//end ClineShapeCWTlTrTBParamRec::ParamString(aString&, char)



long double ClineShapeCWTlTrTBParamRec::ParamValue(int paramNum){
	//returns value of parameter; first varying params, then derived params
	int paramToReport, reportDerived=false;
	if(paramNum<NumParams()){
			paramToReport = paramNum;
			}
		else{//it's a derived param
			reportDerived=true;
			paramToReport = paramNum - NumParams();//renumbered for derived params
			}
	if(!reportDerived){
			switch (paramToReport){
				 case 0:
				 	 return center();
				 	 break;
				 case 1:
				 	 return width();
				 	 break;
				 case 2:
				 	 return thetaL();
				 	 break;
				 case 3:
				 	 return thetaR();
				 	 break;
				 case 4:
				 	 return zL();
				 	 break;
				 case 5:
				 	 return zR();
				 	 break;
				 case 6:
				 	 return leftVal();
				 	 break;
				 case 7:
				 	 return rightVal();
				 	 break;
				 default:
				 	break;
		 		}//end switch
	 	}//if !reportDerived
	 else{//it's a derived parameter
		switch (paramToReport){
			 case 0:
			 	 return xL();
			 	 break;
			 case 1:
			 	 return xR();
			 	 break;
			 case 2:
			 	 return B_L();
			 	 break;
			 case 3:
			 	 return B_R();
			 	 break;
			 case 4:
			 	 return DeltaP();
			 	 break;
			 default:
			 	break;
			 }//end switch
		}//end if derived parameter
	aString errstr("bug: can't return value of param #");
	errstr.cat(paramNum+1);
	errstr.cat(" in a ");errstr.cat(TotalParams());errstr.cat("-parameter cline model");
	aError(errstr);
	return 0.0;//shouldn't get here
	}//end ClineShapeCWTlTrTBParamRec::ParamValue(int )


void ClineShapeCWTlTrTBParamRec::Print(ostream& outFile, long rep, aString& message){
	//usually to screen
	ClineShapeCWParamRec::Print(outFile, rep, message);
	aString outStr("thetaL: ");
	outStr.cat(thetaL(),2,9);
	outStr.separator(2);
	outStr.cat("zL: ");
	outStr.cat(zL(),6,4);
	outStr.separator(2);
	outStr.cat("xL: ");
	outStr.cat(xL(),6,4);
	outFile<<outStr<<endl;
	outStr="thetaR: ";
	outStr.cat(thetaR(),2,9);
	outStr.separator(2);
	outStr.cat("zR: ");
	outStr.cat(zR(),6,4);
	outStr.separator(2);
	outStr.cat("xR: ");
	outStr.cat(xR(),6,4);
	outFile<<outStr<<endl;
	outStr="pL: ";
	outStr.cat(leftVal(),2,9);
	outStr.separator(2);
	outStr.cat("p[xL]: ");
	outStr.cat(B_L(),2,9);
	outFile<<outStr<<endl;
	outStr="pR: ";
	outStr.cat(rightVal(),2,9);
	outStr.separator(2);
	outStr.cat("p[xR]: ");
	outStr.cat(B_R(),2,9);
	outFile<<outStr<<endl;
	outStr="deltaP: ";
	outStr.cat(DeltaP(),2,9);
	outFile<<outStr<<endl;
	}//ClineShapeCWTlTrTBParamRec::Print(ostream&, long, aString&)



long double ClineShapeCWTlTrTBParamRec::rightVal(int /*trait*/){
	return pR_;}


void ClineShapeCWTlTrTBParamRec::rightVal(long double rt, int /*trait*/){
	pR_ = rt;}



int ClineShapeCWTlTrTBParamRec::RJunction(double rightEnd){
	//finds point where right and center cline sectons meet
//	if(!(paramsOn_.Includes(3)) && !(paramsOn_.Includes(5))){
//		xR_ = rightEnd;
//		return 1;
//		}
	return ClineShapeCWTlTrParamRec::RJunction(rightEnd);
	}//end ClineShapeCWTlTrTBParamRec::RJunction(double)
	

void ClineShapeCWTlTrTBParamRec::SetParamValue(int paramNum, long double newVal){
	//set value of parameter; only for varying parameters
	int reportDerived=false;
	if(paramNum>=NumParams()){
			return;}//it's a derived param
	switch (paramNum){
	 case 0:
	 	 center(newVal);
	 	 return;  break;
	 case 1:
	 	 width(newVal);
	 	 return;  break;
	 case 2:
	 	 thetaL(newVal);
	 	 return;  break;
	 case 3:
	 	 thetaR(newVal);
	 	 return;  break;
	 case 4:
	 	 zL(newVal);
	 	 return;  break;
	 case 5:
	 	 zR(newVal);
	 	 return;  break;
	 case 6:
	 	 leftVal(newVal);
	 	 return;  break;
	 case 7:
	 	 rightVal(newVal);
	 	 return;  break;
	 default:
	 	break;
	 	}//end switch
	aString errstr("bug: can't set value of param #");  errstr.cat(paramNum+1);
	errstr.cat(" in a ");  errstr.cat(NumParams());  errstr.cat("-parameter cline model");
	aError(errstr);
	}//end ClineShapeCWTlTrTBParamRec::SetParamValue(int,long double)



void ClineShapeCWTlTrTBParamRec::TitleString(aString& dataline, char sepchar){
	//a list of the values that will be printed to a big file
	ClineShapeCWParamRec::TitleString(dataline, sepchar);
	dataline.cat(sepchar);
	dataline.cat("thetaL");
	dataline.cat(sepchar);
	dataline.cat("zL");
	dataline.cat(sepchar);
	dataline.cat("xL");
	dataline.cat(sepchar);
	dataline.cat("thetaR");
	dataline.cat(sepchar);
	dataline.cat("zR");
	dataline.cat(sepchar);
	dataline.cat("xR");
	dataline.cat(sepchar);
	dataline.cat("pL");
	dataline.cat(sepchar);
	dataline.cat("p[xL]");
	dataline.cat(sepchar);
	dataline.cat("pR");
	dataline.cat(sepchar);
	dataline.cat("p[xR]");
	dataline.cat(sepchar);
	dataline.cat("delta_P]");
	}//end ClineShapeCWTlTrTBParamRec::TitleString(aString&, char)




void ClineShapeCWTlTrTBParamRec::operator=(ParamRec& p){
	//uses type conversion that circumvents usual virtual base class restrictions
	//This means p must actually point to an object of class ClineShapeCWTlTrParamRec
	ClineShapeCWTlTrTBParamRec* pp = (ClineShapeCWTlTrTBParamRec*) p.GetPointerToDerivedSelf();
	lnL_= pp->lnL_;
	lnLmaxMinusLnL_ = pp->lnLmaxMinusLnL_;	
  	c_ = pp->c_;
  	w_ = pp->w_;
	thetaL_ = pp->thetaL_;
	thetaR_ = pp->thetaR_;
	zL_ = pp->zL_;
	zR_ = pp->zR_;
	pL_ = pp->pL_;
	pR_ = pp->pR_;
//	paramOnOffList_ = pp->paramOnOffList_;
//	paramsOn_ = pp->paramsOn_;
	xL_ = pp->xL_;
	xR_ = pp->xR_;
	}//end  ClineShapeCWTlTrTBParamRec::operator=(ParamRec&)





int	operator==(ClineShapeCWTlTrTBParamRec& p, ClineShapeCWTlTrTBParamRec& q){
	return ((p.lnL_ == q.lnL_) &&
			(p.c_ == q.c_) &&
			(p.w_ == q.w_) &&
			(p.thetaL_ == q.thetaL_) &&
			(p.thetaR_ == q.thetaR_) &&
			(p.zL_ == q.zL_) &&
			(p.zR_ == q.zR_) &&
			(p.pL_ == q.pL_) &&
			(p.pR_ == q.pR_) //&&
			//(p.paramOnOffList_ == q.paramOnOffList_) &&
			//(p.paramsOn_ == q.paramsOn_)
			 );
	}//end operator==(ClineShapeCWTlTrTBParamRec&, ClineShapeCWTlTrTBParamRec&)


int	operator!=(ClineShapeCWTlTrTBParamRec& p, ClineShapeCWTlTrTBParamRec& q){
	return !(p==q);
	}//end operator!=(ClineShapeCWTlTrTBParamRec&, ClineShapeCWTlTrTBParamRec&)



#endif


