/****************************************************
*
*	DiseqLikelihood.h
*
*	This calculates the likelihood of a particular value
*	of D, the disequilibrium coefficient, from population genetic data,
*	using a multinomial probability function, for pairs of
*	loci.
*
*****************************************************/

#ifndef DiseqLikelihoodh
#define DiseqLikelihoodh = 1

#include <math.h>
#include "InlineTemplates.h"
#include "Element.cpp"
#include "aList.cpp"
#include "StringClass.h"
#include "aVector.cpp"
#include "aMatrix.cpp"
#include "ParamRec.h"
#include "ClineDiseqParamRec.h"
#include "MetropolisHastings.h"
#include "ClineGeneticData.h"


double ClineDiseqLikelihood(ClineDiseqParamRec& diseqParam, MetropolisHastingsData* data);


#endif
