// HybridIndex.h

//This class holds a hybrid index

#ifndef HybridIndexh
#define HybridIndexh = 1

#include "aList.cpp"
#include "MemoryManager.h"
//definitions for
class HybridIndex;
class HybridIndexByLocation;
class HybridIndexByLocData;


class HybridIndex{
	//stores an average of some set of values measured on an individual
	protected:
		long double hi_;//index value
		int items_;//the number of items that went into the calculation of the index
	public:
		HybridIndex(void): hi_((long double)0.0), items_(0) {}
//		HybridIndex(double h, int items): hi_((long double)h), items_(items) {}
		HybridIndex(long double h, int items): hi_(h), items_(items) {}
		
		HybridIndex(HybridIndex& h):  hi_(h.hi_), items_(h.items_) {}
		HybridIndex(HybridIndex* h):  hi_(h->hi_), items_(h->items_) {}
	
	virtual ~HybridIndex(void){}
	virtual HybridIndex* Duplicate(void);
	
	
		virtual long double hi(void) {return hi_;}
		virtual int items(void) {return items_;}
		
		virtual void hi(long double h) {hi_ = h;}
		virtual void items(int i) {items_ = i;}
		
		friend int operator== (HybridIndex& a, HybridIndex& b);
		friend int operator!= (HybridIndex& a, HybridIndex& b);
	};//end class HybridIndex



#endif
