// HybridIndexByLocation.h

//This class holds a hybrid index with a 1-dimensional spatial location

#ifndef HybridIndexByLocationh
#define HybridIndexByLocationh = 1

#include "HybridIndex.h"
#include "MemoryManager.h"
//definitions for
class HybridIndexByLocation;



class HybridIndexByLocation: public HybridIndex {
	//stores an average of some set of values measured on an individual
	protected:
		long double x_;//1-dimensional location
	public:
		HybridIndexByLocation(void): x_(0.0){}
//		HybridIndexByLocation(double x): x_(x) {}
		HybridIndexByLocation(long double x): x_((long double)x) {}
//		HybridIndexByLocation(double hi, int items,double x): 
//					HybridIndex((long double)hi,items), x_(x) {}
		HybridIndexByLocation(long double hi, int items,long double x): 
					HybridIndex(hi,items), x_(x) {}
		
		HybridIndexByLocation(HybridIndexByLocation& h):  
				HybridIndex(h), x_(h.x_) {}
		HybridIndexByLocation(HybridIndexByLocation* h):  
				HybridIndex(h), x_(h->x_){}
	
	virtual ~HybridIndexByLocation(void){}
	virtual HybridIndex* Duplicate(void);
	
	
		virtual long double 	x(void) {return x_;}
		virtual void 	x(long double xx) {x_ = xx;}
		
		friend int operator== (HybridIndexByLocation& a, HybridIndexByLocation& b);
		friend int operator!= (HybridIndexByLocation& a, HybridIndexByLocation& b);

	};//end class HybridIndexByLocation



#endif


